<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * SugarCRM is a customer relationship management program developed by
 * SugarCRM, Inc. Copyright (C) 2004 - 2007 SugarCRM Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * 
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by SugarCRM".
 ********************************************************************************/
/*********************************************************************************

 * Description:  TODO: To be written.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/

require_once('data/SugarBean.php');
require_once('include/utils.php');

class EcmPayment extends SugarBean {
    var $field_name_map = array();

	var $id;
	var $date_entered;
	var $date_modified;
	var $modified_user_id;
	var $assigned_user_id;
	var $name;
	var $value;
	var $description;
	var $parent_id;
	var $parent_name;
	var $payment_date;
	
	var $module_dir = 'EcmPayments';
	var $table_name = "ecmpayments";
	var $object_name = "EcmPayment";
	
	var $new_schema = true;

	var $additional_column_fields = array('assigned_user_name', 'assigned_user_id');

	function EcmPayment() {
		parent::SugarBean();
		$this->setupCustomFields('EcmPayments');
		foreach($this->field_defs as $field){
        	$this->field_name_map[$field['name']] = $field;
        }
	}
	function get_summary_text(){
		return $this->name;
	}
	function create_list_query($order_by, $where, $show_deleted = 0){
		$custom_join = $this->custom_fields->getJOIN();
		$query ="SELECT ";
        $query.="ecmpayments.*,users.user_name as assigned_user_name";
		if($custom_join)$query.=$custom_join['select'];
        $query.=" FROM ecmpayments ";
		$query.="LEFT JOIN users ON ecmpayments.assigned_user_id=users.id";
		$query.="  ";
		if($custom_join)$query.=$custom_join['join'];
        $where_auto='1=1';
		if($show_deleted==0)$where_auto=" $this->table_name.deleted=0 ";
		elseif($show_deleted==1)$where_auto=" $this->table_name.deleted=1 ";	
        if($where!="")$query.="where $where AND ".$where_auto;
		else $query.="where ".$where_auto;
		if(substr_count($order_by,'.')>0)$query .= " ORDER BY $order_by";
		elseif($order_by != "")$query .= " ORDER BY $order_by";
		else $query .= " ORDER BY ecmpayments.name";		
		return $query;
	}
	function create_export_query($order_by,$where){
		$custom_join = $this->custom_fields->getJOIN();
		$query ="SELECT ";
        $query.="ecmpayments.*,users.user_name as assigned_user_name";
		if($custom_join)$query.=$custom_join['select'];
        $query.=" FROM ecmpayments ";
		$query.="LEFT JOIN users ON ecmpayments.assigned_user_id=users.id";
		$query.="  ";
		if($custom_join)$query.=$custom_join['join'];
        $where_auto='1=1';
		if($show_deleted==0)$where_auto=" $this->table_name.deleted=0 ";
		elseif($show_deleted==1)$where_auto=" $this->table_name.deleted=1 ";	
        if($where!="")$query.="where $where AND ".$where_auto;
		else $query.="where ".$where_auto;
		if(substr_count($order_by,'.')>0)$query .= " ORDER BY $order_by";
		elseif($order_by != "")$query .= " ORDER BY $order_by";
		else $query .= " ORDER BY ecmpayments.name";		
		return $query;
    }
	function fill_in_additional_list_fields(){
	}

	function fill_in_additional_detail_fields(){   
        parent::fill_in_additional_detail_fields();
	}		
	function get_list_view_data(){
		global $current_language;
		$the_array=parent::get_list_view_data();
		$app_list_strings=return_app_list_strings_language($current_language);
		$mod_strings=return_module_language($current_language,'EcmPayments');

	    $the_array['NAME']=(($this->name == "") ? "<em>blank</em>" : $this->name);
	    $the_array['ENCODED_NAME']=$this->name;
		return $the_array;
	}
	function build_generic_where_clause($the_query_string){
		$where_clauses=array();
		$the_query_string=PearDatabase::quote(from_html($the_query_string));
		array_push($where_clauses,"ecmpayments.name like '$the_query_string%'");

		$the_where="";
		foreach($where_clauses as $clause){
			if($the_where!="")$the_where.=" or ";
			$the_where.=$clause;
		}
		return $the_where;
	}
	function set_notification_body($xtpl,$ecmpayment)
	{
		global $mod_strings,$app_list_strings;
		$xtpl->assign("ECMPAYMENT_SUBJECT",$ecmpayment->name);
		return $xtpl;
	}
	
	function bean_implements($interface){
		switch($interface){
			case 'ACL':return true;
		}
		return false;
	}
	
	function save($check_notify=FALSE){
		$id=parent::save($check_notify);
		mysql_query("delete from ecmpayments_ecminvoiceouts where ecmpayment_id='".$id."'");
		for($i=0;$i<100;$i++){
			if($_REQUEST['inv_id'.$i]){
				mysql_query("insert into ecmpayments_ecminvoiceouts(id,ecmpayment_id,ecminvoiceout_id,date_entered,date_modified,deleted,created_by,modified_user_id) values('".create_guid()."','".$id."','".$_REQUEST['inv_id'.$i]."','".date("Y-m-d H:i:s")."','".date("Y-m-d H:i:s")."','0','".$_SESSION['authenticated_user_id']."','".$_SESSION['authenticated_user_id']."')");
			}
		}
		return $id;
	}
}
?>
